//+------------------------------------------------------------------+
//|                                                 DiffFractals.mq4 |
//|                                                        Scriptong |
//|                                                scriptong@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Scriptong"
#property link      "scriptong@mail.ru"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Yellow
#property indicator_color3 Blue
#property indicator_color4 Aqua

extern string    A1 = "   ";
extern int       period  = 200;                           //    
extern string    A2 = "==============================================================";
extern string    A3 = " (0 - , 240 - 4, 1440 - D1, 10080 - W1)";
extern int       TF=0;                                                       // 
extern string    A4 = "==============================================================";
extern string    A5 = "  ,    ";
extern int       MinBars = 4;    //  -    
extern string    A6 = "==============================================================";

extern string    A7 = " ";
extern color     Color1 = Red;
extern color     Color2 = Yellow;
extern color     Color3 = Blue;
extern color     Color4 = Aqua;
extern string    A8 = "==============================================================";

extern string    A9 = "  :  (0-3), ,  ";
extern int       CommentCorner = 2;
extern color     CommentColor = Yellow;
extern int       CommentFontSize = 10;
extern string    A10 = "==============================================================";


//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];

datetime LastBar;
bool Activate;
double Value[];
int Number[],                                  //  ,  
    RefNumber[],                            //    Value  Number 
                                                     //   
    RefCount,                               //    
    Range,
    FFCount;                                            //   
    
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   Activate = False;
   if (period > Bars-1 || period < 4)
     {
      Alert(" period     ", Bars, "  ,  3!");
      return(0);
     } 
  
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,108);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,108);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,108);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,108);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexEmptyValue(3,0.0);
//----
   Range = MathFloor(period/2);
   ArrayResize(Value, Range); 
   ArrayResize(Number, Range); 
   ArrayInitialize(Value, 0); 
   ArrayInitialize(Number, 0); 


   LastBar = 0;
   
   Activate = True;
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for (int i = 1; i < 5; i++)
     {
      if (ObjectFind("DF_Line"+i) == 0)
        ObjectDelete("DF_Line"+i);
      if (ObjectFind("DF_Comment"+i) == 0)
        ObjectDelete("DF_Comment"+i);
      if (ObjectFind("DF_Arrow"+i) == 0)
        ObjectDelete("DF_Arrow"+i);
     }   
     
   for (i = 0; i < period+1; i++)
     {  
      ExtMapBuffer1[i] = 0;  
      ExtMapBuffer2[i] = 0;  
      ExtMapBuffer3[i] = 0;  
      ExtMapBuffer4[i] = 0;  
     } 
//----
   return(0);
  }

//+-------------------------------------------------------------------------------------+
//|                                                                    |
//+-------------------------------------------------------------------------------------+
void DrawLevel(int Num)
{
 //      
 double Average = 0;
 for (int i = 0; i < RefCount; i++)
   Average += Value[RefNumber[i]];
 Average = NormalizeDouble(Average/RefCount, Digits);
 // ---------------------------------------------
 
 switch (Num)
   {
    case 1: color Color = Color1; string Name = "DF_Line1"; break;
    case 2: Color = Color2; Name = "DF_Line2"; break;
    case 3: Color = Color3; Name = "DF_Line3"; break;
    case 4: Color = Color4; Name = "DF_Line4"; break;
   }
 
 if (ObjectFind(Name) < 0)
   {
    ObjectCreate(Name, OBJ_HLINE, 0, 1, Average);
    ObjectSet(Name, OBJPROP_COLOR, Color);
    ObjectSet(Name, OBJPROP_STYLE, STYLE_DASHDOT);
   } 
  else
   ObjectMove(Name, 0, 1, Average); 
}

//+-------------------------------------------------------------------------------------+
//|  ,                                                |
//+-------------------------------------------------------------------------------------+
void DrawPoints(int Num)
{
 for (int i = 0; i < RefCount; i++)
   {
    int B = Number[RefNumber[i]];
    switch(Num)
      {
       case 1:
         ExtMapBuffer1[B] = Open[B];
       break;
       case 2:
         ExtMapBuffer2[B] = Open[B];
       break;
       case 3:
         ExtMapBuffer3[B] = Open[B];
       break;
       case 4:
         ExtMapBuffer4[B] = Open[B];
       break;
      }
    Value[RefNumber[i]] = 0;
    Number[RefNumber[i]] = 0;  
   }   
}

//+-------------------------------------------------------------------------------------+
//|                                          |
//+-------------------------------------------------------------------------------------+
bool FindMinDiff(int First, int Min)
{
 RefCount = 1;
 RefNumber[0] = First;
 double Etalon = Value[First];
 double Delta = Min*Point;
 for (int i = First+1; i < FFCount; i++)
   if (MathAbs(Etalon - Value[i]) <= Delta && Number[i] != 0)
     {
      RefNumber[RefCount] = i;
      RefCount++;
     }
 if (RefCount >= MinBars) return(True);
 else                     return(False);    
}

//+-------------------------------------------------------------------------------------+
//|     BeginBar-EndBar                                         |
//+-------------------------------------------------------------------------------------+
int FindFractals()
{
 FFCount = 0;
 for (int i = 3; i < period && FFCount < Range; i++)
   {
    double FU = iFractals(Symbol(), TF, MODE_UPPER, i);
    if (FU != 0)
      {
       Value[FFCount] = FU;
       Number[FFCount] = i;
       FFCount++;
      }
    FU = iFractals(Symbol(), TF, MODE_LOWER, i);
    if (FU != 0)
      {
       Value[FFCount] = FU;
       Number[FFCount] = i;
       FFCount++;
      }
   }  
}

//+-------------------------------------------------------------------------------------+
//|     ""                                              |
//+-------------------------------------------------------------------------------------+
string PPToStr(int Num)
{
 if ((Num > 4 && Num < 21) || MathMod(Num, 10) == 0) return(" ");
 if (MathMod(Num, 10) == 1) return(" ");
 return(" ");
}
  
//+-------------------------------------------------------------------------------------+
//|                                                             |
//+-------------------------------------------------------------------------------------+
void ShowSummary(int Num, int Points)
{
 switch(Num)
   {
    case 1: color Color = Color1; break;
    case 2: Color = Color2; break;
    case 3: Color = Color3; break;
    case 4: Color = Color4; break;
   }
 
 string Name = "DF_Comment"+Num;
 if (ObjectFind(Name) == -1)
   {
    //  
    if (!ObjectCreate(Name, OBJ_LABEL, 0, 0, 0))
      return;
    ObjectSet(Name, OBJPROP_CORNER, CommentCorner); 
    ObjectSet(Name, OBJPROP_XDISTANCE, CommentFontSize+5);
    ObjectSet(Name, OBJPROP_YDISTANCE, 1 + (Num-1)*(CommentFontSize+2));
   }
 ObjectSetText(Name, Points + PPToStr(Points) + ", " + RefCount + " ",
               CommentFontSize, "Trebushe MS", CommentColor);

 Name = "DF_Arrow"+Num;
 if (ObjectFind(Name) == -1)
   {
    //  
    if (!ObjectCreate(Name, OBJ_LABEL, 0, 0, 0))
      return;
    ObjectSet(Name, OBJPROP_CORNER, CommentCorner); 
    ObjectSet(Name, OBJPROP_XDISTANCE, 1);
    ObjectSet(Name, OBJPROP_YDISTANCE, 1 + (Num-1)*(CommentFontSize+2));
   }
 ObjectSetText(Name, CharToStr(108), CommentFontSize, "Wingdings", Color);
}    
  
//+-------------------------------------------------------------------------------------+
//| Custom indicator iteration function                                                 |
//+-------------------------------------------------------------------------------------+
int start()
  {
   if (!Activate) return(0);
     
   if (LastBar == Time[0]) return(0);
   LastBar = Time[0];
   
   deinit();
   
   FindFractals();
   ArrayResize(RefNumber, FFCount);
   int MaxDiff = (Value[ArrayMaximum(Value, FFCount)] - Value[ArrayMinimum(Value, FFCount)])/Point; 
   
   int LinesCol = 0;
   string Comm = "";
   for (int Diff = 0; Diff < MaxDiff && LinesCol < 4; Diff++)
     for (int FN = 0; FN < FFCount && LinesCol < 4; FN++)
        if (FindMinDiff(FN, Diff))
          {
           LinesCol++;
           ShowSummary(LinesCol, Diff);
           DrawLevel(LinesCol);
           DrawPoints(LinesCol);
          }
   
   WindowRedraw();
   
   return(0);
  }

