//+--------------------------------------------------------------------------------------------+
//|   Fractal_Candles_SR_v3.mq4
//+--------------------------------------------------------------------------------------------+
#property indicator_chart_window
#include <stdlib.mqh>
#property indicator_buffers 5

extern color ResColor = Green;
extern color SupColor = Crimson;
extern color UpColor = MediumSeaGreen;
extern color DnColor = Red;
extern int CandleWidth = 5;
extern bool SplitCandles = true;

double MyPoint,ev=EMPTY_VALUE;

double Res[];
double Sup[];
double Up[];
double Dn[];
double Fractal[];

int init()
{
   IndicatorBuffers(5);

   SetIndexStyle(0,DRAW_LINE,STYLE_DOT,1,ResColor);
   SetIndexBuffer(0,Res);
   SetIndexLabel(0,"Resistance");
   
   SetIndexStyle(1,DRAW_LINE,STYLE_DOT,1,SupColor);
   SetIndexBuffer(1,Sup);
   SetIndexLabel(1,"Support");
   
   SetIndexStyle(2,DRAW_HISTOGRAM,0,CandleWidth,UpColor);
   SetIndexBuffer(2,Up);

   SetIndexStyle(3,DRAW_HISTOGRAM,0,CandleWidth,DnColor);
   SetIndexBuffer(3,Dn);

   SetIndexStyle(4,DRAW_NONE);
   SetIndexBuffer(4,Fractal);
   SetIndexLabel(4,"Fractal");

   MyPoint = Point;
	if (Digits == 5 || (Digits == 3 && StringFind(Symbol(), "JPY") != -1))
	{
      MyPoint = Point*10;
	}
	if (Digits == 6 || (Digits == 4 && StringFind(Symbol(), "JPY") != -1))
	{
      MyPoint = Point*100;
	}

   return(0);
}

int deinit()
{
   return(0);
}

int start()
{
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1); //---- check for possible errors
   if(counted_bars>0) counted_bars--; //---- last counted bar will be recounted
   
   for (int i=Bars-counted_bars;i>=0;i--)
   {
      Res[i] = Res[i+1];
      Sup[i] = Sup[i+1];
      Fractal[i] = Fractal[i+1];
            
// find sup/res

      if ((High[i] > High[i+1] && High[i] > High[i+2]) && 
          (Low[i] < Low[i+1] && Low[i] < Low[i+2]))
      {
         Res[i] = High[i];
         Sup[i] = Low[i];
         
         if (Close[i] > Open[i])
         {
            Fractal[i] = 1;   
         }
         
         if (Close[i] < Open[i])
         {
            Fractal[i] = -1;   
         }
      }
      else
      if (High[i] > High[i+1] && High[i] > High[i+2])
      {
         Res[i] = High[i];
         Fractal[i] = 1;
      }
      else
      if (Low[i] < Low[i+1] && Low[i] < Low[i+2])
      {
         Sup[i] = Low[i];
         Fractal[i] = -1;
      }

// color candles

      Up[i] = ev;
      Dn[i] = ev;
      
      if (CompareDoubles(High[i],Res[i]) || Fractal[i] == -1)
      {
         if (Close[i] > Open[i])
         {
            if (Close[i] > Res[i+1] && Open[i] < Res[i+1] && SplitCandles)
            {
               Up[i] = MathMax(Open[i],Close[i]);
               Dn[i] = MathMax(Open[i],Res[i+1]);
            }
            else
            {
               Up[i] = MathMax(Open[i],Close[i]);
               Dn[i] = MathMin(Open[i],Close[i]);
            }
         }
      }

      if (CompareDoubles(Low[i],Sup[i]) || Fractal[i] == 1)
      {
         if (Close[i] < Open[i])
         {
            if (Close[i] < Sup[i+1] && Open[i] > Sup[i+1] && SplitCandles)
            {
               Dn[i] = MathMin(Open[i],Sup[i+1]);
               Up[i] = MathMin(Open[i],Close[i]);
            }
            else
            {
               Dn[i] = MathMax(Open[i],Close[i]);
               Up[i] = MathMin(Open[i],Close[i]);
            }
         }
      }
   }
}

