//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"


#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red  
#property indicator_color2 LimeGreen 
#property indicator_width1 2
#property indicator_width2 2

extern string  timeFrame        = "current time frame";
extern bool    showJustOneArrow = true;
extern int     showArrowType    = 0;
extern bool    alertsOn         = true;
extern bool    alertsMessage    = true;
extern bool    alertsSound      = false;
extern bool    alertsEmail      = false;

//
//
//
//
//

extern string note7            = "Arrow Type";
extern string note8            = "0=default,1=Thick,2=Thin,3=Hollow";
extern string note9            = "4=Round,5=Fractal,6=Diagonal Thin";
extern string note10           = "7=Diagonal Thick,8=Diagonal Hollow";
extern string note11           = "9=Thumb,10=Finger";
extern int    ArrowType        = 2;

//
//
//
//
//

double   Buffer1[];
double   Buffer2[];
int      TimeFrame;

//
//
//
//
//

string IndicatorFileName;
bool   ReturningBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorDigits(Digits);
   switch(ArrowType)
   {
      case 0  : int arrowUp = 119; int arrowDown=119; break;
      case 1  :     arrowUp = 234;     arrowDown=233; break;
      case 2  :     arrowUp = 226;     arrowDown=225; break;
      case 3  :     arrowUp = 242;     arrowDown=241; break;
      case 4  :     arrowUp = 222;     arrowDown=221; break;
      case 5  :     arrowUp = 218;     arrowDown=217; break;
      case 6  :     arrowUp = 230;     arrowDown=228; break;
      case 7  :     arrowUp = 238;     arrowDown=236; break;
      case 8  :     arrowUp = 248;     arrowDown=246; break;
      case 9  :     arrowUp =  68;     arrowDown= 67; break;
      case 10 :     arrowUp =  72;     arrowDown= 71; break;
   }      
   SetIndexBuffer(0,Buffer1); SetIndexEmptyValue(0,0); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,arrowUp);   SetIndexLabel(0,"Fractal Up");
   SetIndexBuffer(1,Buffer2); SetIndexEmptyValue(1,0); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,arrowDown); SetIndexLabel(1,"Fractal Down");

      IndicatorFileName = WindowExpertName();
      ReturningBars     = (timeFrame == "returnBars"); if (ReturningBars) return(0);

   //
   //
   //
   //
   //

   showArrowType = MathMax(MathMin(showArrowType,2),0);
   TimeFrame = stringToTimeFrame(timeFrame);
   IndicatorShortName("Ratio Fractals"+timeFrameToString(TimeFrame));
   return(0);
}
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMax(MathMin(Bars-counted_bars,Bars-1),4);
           if (ReturningBars)  { Buffer1[0] = limit+1; return(0); }
           if (TimeFrame > Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,IndicatorFileName,"returnBars",0,0)*TimeFrame/Period()));

   //
   //
   //
   //
   //
   
	for(i = limit; i >= 0; i--)
   {
		Buffer1[i] = 0;
		Buffer2[i] = 0;
		
      //
      //
      //
      //
      //
	  	
         int y = iBarShift(NULL,TimeFrame,Time[i]);
         if (showJustOneArrow) 
         {
            //
            //
            //
            //
            //
            
            int yp = iBarShift(NULL,TimeFrame,Time[i+1]);
            if (iTime(NULL,TimeFrame,y) != iTime(NULL,TimeFrame,yp))
            {
               switch(showArrowType)
               {
                  case 0:
                     Buffer1[i]=iFractals(NULL,TimeFrame,MODE_UPPER,y);
                     Buffer2[i]=iFractals(NULL,TimeFrame,MODE_LOWER,y);    
                     break;
                  case 1:
                     Buffer1[i+1]=iFractals(NULL,TimeFrame,MODE_UPPER,yp);
                     Buffer2[i+1]=iFractals(NULL,TimeFrame,MODE_LOWER,yp);    
                     break;
               }
            }
            if (showArrowType==2)
            {
               double fracUp = iFractals(NULL,TimeFrame,MODE_UPPER,y);
               double fracDn = iFractals(NULL,TimeFrame,MODE_LOWER,y);
                  if (compare(fracUp,High[i])) Buffer1[i] = fracUp;
                  if (compare(fracDn,Low[i]) ) Buffer2[i] = fracDn;
            }
            
            //
            //
            //
            //                  
            //
            
         }
         else
         {
            Buffer1[i]=iFractals(NULL,TimeFrame,MODE_UPPER,y);
            Buffer2[i]=iFractals(NULL,TimeFrame,MODE_LOWER,y);    
         }
   }

   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      for (i=0; i<Bars; i++)
      {
         if (Buffer1[i] != 0) break;
         if (Buffer2[i] != 0) break;
      }
      datetime barTime = iTime(NULL,TimeFrame,iBarShift(NULL,TimeFrame,Time[i]));
      int      barNo   = iBarShift(NULL,0,barTime);

         //
         //
         //
         //
         //
         
         if (Buffer2[i] != 0 ) doAlert(barNo,"up");
         if (Buffer1[i] != 0 ) doAlert(barNo,"down");
   }
   return(0);
 }


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

bool compare(double first, double second)
{
   return(NormalizeDouble(first,Digits)==NormalizeDouble(second,Digits));
}
void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Fractals trend changed to  ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Fractals "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}