//+------------------------------------------------------------------+
//|                                                FractalsMD_v1.mq4 |
//|                        Copyright  2006-09, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006-09, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Aqua
#property indicator_color2 Magenta
#property indicator_color3 DodgerBlue
#property indicator_color4 Tomato
#property indicator_color5 Blue
#property indicator_color6 Red
#property indicator_color7 Lime
#property indicator_color8 Orange

#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 2
#property indicator_width6 2
#property indicator_width7 3
#property indicator_width8 3
//---- input parameters

extern bool alertsOn       = true;
extern bool alertsOnLevel1 = false;
extern bool alertsOnLevel2 = true;
extern bool alertsOnLevel3 = true;
extern bool alertsOnLevel4 = true;
extern bool alertsMessage  = true;
extern bool alertsSound    = false;
extern bool alertsEmail    = false;

//---- buffers
double UpBuffer[];
double DnBuffer[];
double UpBuffer1[];
double DnBuffer1[];
double UpBuffer2[];
double DnBuffer2[];
double UpBuffer3[];
double DnBuffer3[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexStyle(7,DRAW_ARROW);
   
   SetIndexArrow(0,159);
   SetIndexArrow(1,159);
   SetIndexArrow(2,162);
   SetIndexArrow(3,162);
   SetIndexArrow(4,162);
   SetIndexArrow(5,162);
   SetIndexArrow(6,162);
   SetIndexArrow(7,162);
   
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DnBuffer);
   SetIndexBuffer(2,UpBuffer1);
   SetIndexBuffer(3,DnBuffer1);
   SetIndexBuffer(4,UpBuffer2);
   SetIndexBuffer(5,DnBuffer2);
   SetIndexBuffer(6,UpBuffer3);
   SetIndexBuffer(7,DnBuffer3);
//---- name for DataWindow and indicator subwindow label
   short_name="Fractals MD";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Up 1D ");
   SetIndexLabel(1,"Down 1D");
   SetIndexLabel(2,"Up 2D ");
   SetIndexLabel(3,"Down 2D");
   SetIndexLabel(4,"Up 3D ");
   SetIndexLabel(5,"Down 3D");
   SetIndexLabel(4,"Up 4D ");
   SetIndexLabel(5,"Down 4D");
//----
   SetIndexDrawBegin(0,0);
   SetIndexDrawBegin(1,0);
   SetIndexDrawBegin(2,0);
   SetIndexDrawBegin(3,0);
   SetIndexDrawBegin(4,0);
   SetIndexDrawBegin(5,0);
   SetIndexDrawBegin(6,0);
   SetIndexDrawBegin(7,0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Fractals4D_v1                                                         |
//+------------------------------------------------------------------+
int start()
{
int      counted_bars=IndicatorCounted();
int  	   shift, upbar0, upbar1, upbar2, dnbar0, dnbar1, dnbar2;
int      upbar01, upbar11 ,upbar21 ,dnbar01 ,dnbar11 ,dnbar21;
double   High1,Low1;			

   for (shift=Bars-1;shift>=0;shift--)	
	{
   UpBuffer[shift]=0.0;
   DnBuffer[shift]=0.0;
   UpBuffer1[shift]=0.0;
   DnBuffer1[shift]=0.0;
   UpBuffer2[shift]=0.0;
   DnBuffer2[shift]=0.0;
   UpBuffer3[shift]=0.0;
   DnBuffer3[shift]=0.0;
   }
 
   if ( counted_bars < 0 )  return(0);
      
   for(shift=Bars-1;shift>=0;shift--) 
   {	
// 1st Up dimension fractals
	High1=High[shift];
	if (High[shift+1]<=High1 && High[shift-1]<High1 && High[shift-1] > 0) UpBuffer[shift]=High1;
// 2nd Up dimension fractals	
      if (UpBuffer[shift]>0)
	   {
	   if (upbar1>shift) upbar2=upbar1; 
	   if (upbar0>shift) upbar1=upbar0;
	   upbar0=shift;
	   if (UpBuffer[upbar2]<=UpBuffer[upbar1] && UpBuffer[upbar0]<UpBuffer[upbar1]) UpBuffer1[upbar1]=UpBuffer[upbar1];
	   }
//1st Down dimension fractals	
	Low1=Low[shift];
	if (Low[shift+1]>=Low1 && Low[shift-1]>Low1 && Low[shift-1]>0) DnBuffer[shift]=Low1;
//2nd Down dimension fractals	
	   if (DnBuffer[shift]>0)
	   {
	   if (dnbar1>shift) dnbar2=dnbar1; 
	   if (dnbar0>shift) dnbar1=dnbar0;
	   dnbar0=shift;
	   if (DnBuffer[dnbar2]>=DnBuffer[dnbar1] && DnBuffer[dnbar0]>DnBuffer[dnbar1]) DnBuffer1[dnbar1]=DnBuffer[dnbar1];
	   }
	}
   
   
   for (shift=Bars-1;shift>=1;shift--)	
	{	
//3rd Up dimension fractals
	   if (UpBuffer1[shift]>0)
	   {
	   if (upbar11>shift) upbar21=upbar11; 
	   if (upbar01>shift) upbar11=upbar01;
	   upbar01=shift;
	   if (UpBuffer1[upbar21]<=UpBuffer1[upbar11] && UpBuffer1[upbar01]<UpBuffer1[upbar11]) 
	   UpBuffer2[upbar11]=UpBuffer1[upbar11];
	   }	
//3rd Down dimension fractals	
	   if (DnBuffer1[shift]>0)
	   {
	   if (dnbar11>shift) dnbar21=dnbar11; 
	   if (dnbar01>shift) dnbar11=dnbar01;
	   dnbar01=shift;
	   if (DnBuffer1[dnbar21]>=DnBuffer1[dnbar11] && DnBuffer1[dnbar01]>DnBuffer1[dnbar11]) 
	   DnBuffer2[dnbar11]=DnBuffer[dnbar11];
	   }
	}
	
	upbar01=0;upbar11=0;upbar21=0;dnbar01=0;dnbar11=0;dnbar21=0;
	
	for (shift=Bars-1;shift>=1;shift--)	
	{	
//4th Up dimension fractals
	   if (UpBuffer2[shift]>0)
	   {
	   if (upbar11>shift) upbar21=upbar11; 
	   if (upbar01>shift) upbar11=upbar01;
	   upbar01=shift;
	   if (UpBuffer2[upbar21]<=UpBuffer2[upbar11] && UpBuffer2[upbar01]<UpBuffer2[upbar11]) 
	   UpBuffer3[upbar11]=UpBuffer2[upbar11];
	   }	
//4th Down dimension fractals	
	   if (DnBuffer2[shift]>0)
	   {
	   if (dnbar11>shift) dnbar21=dnbar11; 
	   if (dnbar01>shift) dnbar11=dnbar01;
	   dnbar01=shift;
	   if (DnBuffer2[dnbar21]>=DnBuffer2[dnbar11] && DnBuffer2[dnbar01]>DnBuffer2[dnbar11]) 
	   DnBuffer3[dnbar11]=DnBuffer2[dnbar11];
	   }
	}

   //
   //
   //    alerting part
   //
   //
   
   static datetime previousLevel1 = -1; static int previousSignal1 = 0;
   static datetime previousLevel2 = -1; static int previousSignal2 = 0;
   static datetime previousLevel3 = -1; static int previousSignal3 = 0;
   static datetime previousLevel4 = -1; static int previousSignal4 = 0;
   
   if (alertsOn)
   {
      int currentBar1=-1;
      int currentBar2=-1;
      int currentBar3=-1;
      int currentBar4=-1;
      for (int a=0; a<Bars; a++)
      {
         if (currentBar1 == -1) if (UpBuffer[a]>0  || DnBuffer[a]>0)  currentBar1 = a;
         if (currentBar2 == -1) if (UpBuffer1[a]>0 || DnBuffer1[a]>0) currentBar2 = a;
         if (currentBar3 == -1) if (UpBuffer2[a]>0 || DnBuffer2[a]>0) currentBar3 = a;
         if (currentBar4 == -1) if (UpBuffer3[a]>0 || DnBuffer3[a]>0) currentBar4 = a;
         if (currentBar1 != -1 &&
             currentBar2 != -1 &&
             currentBar3 != -1 &&
             currentBar4 != -1) break;
      }

      //
      //
      //
      //
      //
      
      if (alertsOnLevel1) checkAlert(currentBar1,previousLevel1,previousSignal1,UpBuffer ,DnBuffer ,"level 1");
      if (alertsOnLevel2) checkAlert(currentBar2,previousLevel2,previousSignal2,UpBuffer1,DnBuffer1,"level 2");
      if (alertsOnLevel3) checkAlert(currentBar3,previousLevel3,previousSignal3,UpBuffer2,DnBuffer2,"level 3");
      if (alertsOnLevel4) checkAlert(currentBar4,previousLevel4,previousSignal4,UpBuffer3,DnBuffer3,"level 4");
   }
   	
return(0);
}

  
//+------------------------------------------------------------------+
//|                                                             
//+------------------------------------------------------------------+
//
//
//
//
//

void checkAlert(int currentBar, datetime& previousLevel, int& previousSignal, double& upBuffer[], double& dnBuffer[], string text)
{
   int previousBar = iBarShift(NULL,0,previousLevel);
   int currentSignal;
         if (upBuffer[currentBar]>0)                           currentSignal = -1;
         if (dnBuffer[currentBar]>0)                           currentSignal =  1;
         if (dnBuffer[currentBar]>0 && upBuffer[currentBar]>0) currentSignal =  0;

   //
   //
   //
   //
   //
   
   if (currentBar != previousBar || currentSignal != previousSignal)
   {
      if (currentSignal != previousSignal && currentBar > previousBar && previousLevel != -1)
            string alertText = " reverted to ";
      else         alertText = " signal ";            
      switch(currentSignal)
      {
         case  0 : doAlert(text+alertText+"up/down"); break;
         case  1 : doAlert(text+alertText+"up");      break;
         case -1 : doAlert(text+alertText+"down");
      }               
 
      //
      //
      //
      //
      //
              
      previousLevel  = Time[currentBar];
      previousSignal = currentSignal;
   }
}

//
//
//
//
//

void doAlert(string doWhat)
{
   string message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Fractals MD ",doWhat);
      if (alertsMessage) Alert(message);
      if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Fractals MD "),message);
      if (alertsSound)   PlaySound("alert2.wav");
}