#property copyright "Scriptong"
#property link      "http://autograf.dp.ua"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Yellow

//---- input parameters
extern string    A1 = "     (  2)";
extern int       ExtremumRange = 15; 
extern string    A2 = "     ";
extern int       BitPoints = 10;       

double Ext1[],                                        //  
       Ext2[],                                        //  
       HistUp[],                                      //   ""
       HistDown[],                                    //   ""
       HistFlat[];                                    //   ""
int NUp1,                                             //    
    NUp2,                                             //    
    NDn1,                                             //    
    NDn2,                                             //     
    center;                                           //    ..
                                                      // ..ExtremumRange
double UpV1,                                          //    
       UpV2,                                          //    
       DnV1,                                          //    
       DnV2;                                          //    
string prefix = "RFSAR_";                             //    
                                                      // ..  
                                                      // ..  ,..
                                                      // .. 
int LastLineType;//    : -1 - , 1 - 
datetime LastLine,              //     (..
                                // ..    )
         LastLabel;             //                                      

//+-------------------------------------------------------------------------------------+
//| Custom indicator initialization function                                            |
//+-------------------------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(5);
// - 1 - ===================     ===================
   if (ExtremumRange % 2 == 0) 
     {
      ExtremumRange++;
      Alert("   ExtremumRange.     ",
            ExtremumRange);
     }
   if (ExtremumRange < 3)
     {
      Alert("    ExtremumRange.   3");
      ExtremumRange = 3;
     }   
   center = ExtremumRange/2 + 1;
// - 1 - ============================   ===================================

// - 2 - ===================    ===========================
   SetIndexBuffer(0, HistUp);
   SetIndexBuffer(1, HistDown);
   SetIndexBuffer(2, HistFlat);
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(3, Ext1);
   SetIndexBuffer(4, Ext2);
// - 2 - ============================   ===================================
   LastLine = 0;
   LastLabel = 0;

   return(0);
  }
//+-------------------------------------------------------------------------------------+
//| Custom indicator deinitialization function                                          |
//+-------------------------------------------------------------------------------------+
int deinit()
  {
//----
   for (int i = ObjectsTotal()-1; i >= 0; i--)
     if (StringSubstr(ObjectName(i), 0, StringLen(prefix)) == prefix)
       ObjectDelete(ObjectName(i));
//----
   return(0);
  }

//+-------------------------------------------------------------------------------------+
//|                                                            |
//+-------------------------------------------------------------------------------------+
void ShowTrend(datetime time1, double price1, datetime time2, double price2, 
               datetime currtime, int x1, int x2, int xn, color Color)
  {
   string name = prefix + time2;                      //   :..
                                                      // .. + 
   double b = (price2*x1 - price1*x2)/(x1 - x2);      //   B 
   if (x2 != 0)                                       //  x2   , ..
     {                                                // .. ..
      double k = (price2 - b)/x2;                     // .. ,  ..
      double y2 = k*xn + b;                           // ..  
     }
    else                                              //     B
     y2 = b;  
   if (ObjectFind(name) < 0)                          //    
     {
      ObjectCreate(name, OBJ_TREND, 0, time1, price1, currtime, y2); //  
      ObjectSet(name, OBJPROP_RAY, true);             //     
      ObjectSet(name, OBJPROP_COLOR, Color);          //  
     }
  }

//+-------------------------------------------------------------------------------------+
//|                                         |
//+-------------------------------------------------------------------------------------+
void ShowLabel(datetime time1, double price1, color Color)
  {
   string name = prefix + "L" + time1;                //   :..
                                                      // .. + 
   if (ObjectFind(name) < 0)                          //    
     {
      ObjectCreate(name, OBJ_ARROW, 0, time1, price1);//  
      ObjectSet(name, OBJPROP_COLOR, Color);          //   
      ObjectSet(name, OBJPROP_ARROWCODE, 6);          //     
     }
  }

//+-------------------------------------------------------------------------------------+
//|                                                   |
//+-------------------------------------------------------------------------------------+
void HideLineRay(datetime time)
  {
   if (LastLine > 0 && LastLine != time)              //    
     {
      string name = prefix + LastLine;                //    
      if (ObjectFind(name) == 0)                      //   , ..
        ObjectSet(name, OBJPROP_RAY, false);          // ..   
     }
  }
  
//+-------------------------------------------------------------------------------------+
//|                                             |
//+-------------------------------------------------------------------------------------+
void CreateArray(int limit)
  {
   for (int i = limit; i >= 0; i--)                 //    
     {
      Ext1[i] = 0;                           //       
      Ext2[i] = 0;                           //       
// - 1 - ===========================   ==============================
      bool found = false;                     //    (false - )
      double cur = High[i+center]; //        ..
                                   // ..  ExtremumRange 
      if (cur>High[i+1] && cur>High[i+ExtremumRange]) //     ,.. 
        found=true;                                   // .., ,  
       else 
        found=false;                                  //   
      if (found)                                      //   ..
        for (int j=1;j<center;j++)                    // .. 
          if (cur <= High[i+center-j] || cur < High[i+center+j])// 
            {                                         // ..  .  ..
             found = false;                           // ..  , ..
             break;                                   // ..  
            }
      if (found)                                      //   , .. 
         Ext1[i+center] = cur;                        // .. 
// - 1 - ==============================    ================================

// - 2 - ============================   ==============================
      found = false;                          //    (false - )
      cur = Low[i+center];         //        ..
                                   // ..  ExtremumRange 
      if (cur<Low[i+1] && cur<Low[i+ExtremumRange])   //     ,..
        found = true;                                 // .., ,  
       else                                           //   
        found = false;                                //   ..
      if (found)                                      // .. 
        for (int k=1;k<center;k++)
          if (cur >= Low[i+center-k] || cur > Low[i+center+k]) //  
            {                                         // ..  .  ..
             found = false;                           // ..  , ..
             break;                                   // ..  
            }
      if (found)                                      //   , .. 
        Ext2[i+center] = cur;                         // .. 
// - 2 - =============================    =================================
     }
  }  
    
//+-------------------------------------------------------------------------------------+
//|                                                |
//+-------------------------------------------------------------------------------------+
void ExtremumsFind(int limit)
  {
// - 1 - =========  ,      ============
   NUp1 = 0; NUp2 = 0; NDn1 = 0; NDn2 = 0;
   UpV1 = 0; UpV2 = 0; DnV1 = 0; DnV2 = 0;
// - 1 - =============================   ==================================

   for (int i = limit + center + 1; i < Bars && (NUp2 == 0 || NDn2 == 0); i++)// -
     {//  center+1 ,     " ",  ..
      // ..   " ".  ,..
      // ..        .    

// - 2 - ================================    =============================
      if (Ext1[i] > 0)                                //  
        if (NUp1 == 0)                                //     
          {
           NUp1 = i;                                  //   
           UpV1 = Ext1[i];                            //   
          }
         else                                         //    
          if (NUp2 == 0)                              //    
            {
             NUp2 = i;                                //   
             UpV2 = Ext1[i];                          //   
            }
// - 2 - ================================   ===============================

// - 3 - ================================    ==============================
      if (Ext2[i] > 0)                                //  
        if (NDn1 == 0)                                //     
          {
           NDn1 = i;                                  //   
           DnV1 = Ext2[i];                            //   
          }
         else                                         //    
          if (NDn2 == 0)                              //     
            {
             NDn2 = i;                                //   
             DnV2 = Ext2[i];                          //   
            }
// - 3 - ================================   ===============================
      }
  }
    
//+-------------------------------------------------------------------------------------+
//|  ,    ,         |
//+-------------------------------------------------------------------------------------+
void Results(int limit)
  {
   for (int i = limit; i >=0; i--)
     {
// - 1 - =================     ===================
      if (Ext1[i+center] > 0)                         //    
        {
         NUp2 = NUp1;                                 //   
         UpV2 = UpV1;
         NUp1 = i+center;                             //    
         UpV1 = Ext1[i+center];
        } 
// - 1 - ============================   ===================================

// - 2 - =================     ====================
      if (Ext2[i+center] > 0)                         //    
        {
         NDn2 = NDn1;                                 //    
         DnV2 = DnV1;
         NDn1 = i+center;                             //    
         DnV1 = Ext2[i+center];                       
        } 
// - 2 - ============================   ===================================

// - 3 - ==============       =============
      if (LastLabel < LastLine+Period()*60*center)    //    ..
        {                                             // .. ,  ..
                                                      // .. ..
                                                      // ../
         if (LastLineType < 0)         //     
           {
            double linevalue = ObjectGetValueByShift(prefix+LastLine, i)-BitPoints*Point;
            // linevalue -         ..
            // ..BitPoints 
            if (Low[i] < linevalue)                   //    
              {
               LastLabel = Time[i];                   //    
               linevalue = MathMin(linevalue, Open[i]);//   
               ShowLabel(LastLabel, linevalue, indicator_color2);//   
              }
           }   
         if (LastLineType > 0)     //     
           {
            linevalue = ObjectGetValueByShift(prefix+LastLine, i)+BitPoints*Point;
            if (High[i] > linevalue)                  //    
              {
               LastLabel = Time[i];                   //    
               linevalue = MathMax(linevalue, Open[i]);//   
               ShowLabel(LastLabel, linevalue, indicator_color1);//   
              }
           }  
        }
// - 3 - ==============================   =================================

// - 4 - ======================     =====================
      if (UpV1 > UpV2 && DnV1 > DnV2)                 //     .. 
        {                                             // ..   
         HistUp[i] = 2;                               //   ""
         HistDown[i] = 0;                             //   ""
         HistFlat[i] = 0;                             //   ""
         if (LastLine != Time[NDn1])                  //    
           {
            HideLineRay(Time[NDn1]);                  //    ..
                                                      // ..
            LastLine = Time[NDn1];                    //   
            ShowTrend(Time[NDn2], DnV2, LastLine, DnV1, Time[i], NDn2, NDn1, i, 
                      indicator_color2);              //   
            LastLineType = -1;                        //   
           } 
        }
// - 4 - ==============================   =================================

// - 5 - ======================     =====================
       else
        if (UpV1 < UpV2 && DnV1 < DnV2)               //     .. 
          {                                           // ..   
           HistUp[i] = 0;                             //   ""
           HistDown[i] = 2;                           //   ""
           HistFlat[i] = 0;                           //   ""
           if (LastLine != Time[NUp1])
             {
              HideLineRay(Time[NUp1]);
              LastLine = Time[NUp1];
              ShowTrend(Time[NUp2], UpV2, LastLine, UpV1, Time[i], NUp2, NUp1, i,
                        indicator_color1);
              LastLineType = 1;                       //   
            } 
          }
// - 5 - ==============================   =================================

// - 6 - ============================   -  =========================
         else
          {
           HistUp[i] = 0;                             //   ""
           HistDown[i] = 0;                           //   ""
           HistFlat[i] = 2;                           //   ""
          }   
// - 6 - ==============================   =================================
     }
}
    
//+-------------------------------------------------------------------------------------+
//| Custom indicator iteration function                                                 |
//+-------------------------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();            //   ..
                                                      // ..  
                                                      // ..
   int limit = Bars-counted_bars;                     //     
   CreateArray(limit);                                //   
   ExtremumsFind(limit);                              //    ..
                                                      // ..
   Results(limit);                                    //   
   return(0);
  }

